]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
87fa6fe4a8aaedeb19dd90bff26484ecc837f732
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     [ -e "${GNUPGHOME}/gpg.conf" ] && return
113     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
114     at_exit_function _gnupg_exit
115     mkdir -p -m 0700 "$GNUPGHOME"
116     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
117     test_debug "cat $GNUPGHOME/import.log"
118     if (gpg --quick-random --version >/dev/null 2>&1) ; then
119         echo quick-random >> "$GNUPGHOME"/gpg.conf
120     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
121         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
122     fi
123     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
124
125     # Change this if we ship a new test key
126     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
127     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
128     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
129 }
130
131 add_gpgsm_home ()
132 {
133     local fpr
134     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
135     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
136     at_exit_function _gnupg_exit
137     mkdir -p -m 0700 "$GNUPGHOME"
138     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
139         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
140         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
141               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
142     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
143     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
144     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
145     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
146     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
147     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
148               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
149     test_debug "cat $GNUPGHOME/import.log"
150 }
151
152 # Each test should start with something like this, after copyright notices:
153 #
154 # test_description='Description of this test...
155 # This test checks if command xyzzy does the right thing...
156 # '
157 # . ./test-lib.sh || exit 1
158
159 color=maybe
160
161 while test "$#" -ne 0
162 do
163         case "$1" in
164         -d|--debug)
165                 debug=t; shift ;;
166         -i|--immediate)
167                 immediate=t; shift ;;
168         -h|--help)
169                 help=t; shift ;;
170         -v|--verbose)
171                 verbose=t; shift ;;
172         -q|--quiet)
173                 quiet=t; shift ;;
174         --with-dashes)
175                 with_dashes=t; shift ;;
176         --no-color)
177                 color=; shift ;;
178         --no-python)
179                 # noop now...
180                 shift ;;
181         --valgrind)
182                 valgrind=t; verbose=t; shift ;;
183         --tee)
184                 shift ;; # was handled already
185         *)
186                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
187         esac
188 done
189
190 if test -n "$debug"; then
191     print_subtest () {
192         printf " %-4s" "[$((test_count - 1))]"
193     }
194 else
195     print_subtest () {
196         true
197     }
198 fi
199
200 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
201
202 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
203                 TERM=$ORIGINAL_TERM &&
204                 export TERM &&
205                 tput bold
206                 tput setaf
207                 tput sgr0
208         ) >/dev/null 2>&1
209 then
210         color=t
211 else
212         color=
213 fi
214
215 if test -n "$color"; then
216         say_color () {
217                 (
218                 TERM=$ORIGINAL_TERM
219                 export TERM
220                 case "$1" in
221                         error) tput bold; tput setaf 1;; # bold red
222                         skip)  tput bold; tput setaf 2;; # bold green
223                         pass)  tput setaf 2;;            # green
224                         info)  tput setaf 3;;            # brown
225                         *) test -n "$quiet" && return;;
226                 esac
227                 shift
228                 printf " "
229                 printf "$@"
230                 tput sgr0
231                 print_subtest
232                 )
233         }
234 else
235         say_color() {
236                 test -z "$1" && test -n "$quiet" && return
237                 shift
238                 printf " "
239                 printf "$@"
240                 print_subtest
241         }
242 fi
243
244 error () {
245         say_color error "error: $*\n"
246         GIT_EXIT_OK=t
247         exit 1
248 }
249
250 say () {
251         say_color info "$*"
252 }
253
254 test "${test_description}" != "" ||
255 error "Test script did not set test_description."
256
257 if test "$help" = "t"
258 then
259         echo "Tests ${test_description}"
260         exit 0
261 fi
262
263 test_description_printed=
264 print_test_description ()
265 {
266         test -z "$test_description_printed" || return 0
267         echo
268         echo $this_test: "Testing ${test_description}"
269         test_description_printed=1
270 }
271 if [ -z "$NOTMUCH_TEST_QUIET" ]
272 then
273         print_test_description
274 fi
275
276 test_failure=0
277 test_count=0
278 test_fixed=0
279 test_broken=0
280 test_success=0
281
282 declare -a _exit_functions=()
283
284 at_exit_function () {
285         _exit_functions=($1 ${_exit_functions[@]/$1})
286 }
287
288 rm_exit_function () {
289         _exit_functions=(${_exit_functions[@]/$1})
290 }
291
292 _exit_common () {
293         code=$?
294         trap - EXIT
295         set +ex
296         for _fn in ${_exit_functions[@]}; do $_fn; done
297         rm -rf "$TEST_TMPDIR"
298 }
299
300 trap_exit () {
301         _exit_common
302         if test -n "$GIT_EXIT_OK"
303         then
304                 exit $code
305         else
306                 exec >&6
307                 say_color error '%-6s' FATAL
308                 echo " $test_subtest_name"
309                 echo
310                 echo "Unexpected exit while executing $0. Exit code $code."
311                 exit 1
312         fi
313 }
314
315 trap_signal () {
316         _exit_common
317         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
318         exit $code
319 }
320
321 die () {
322         _exit_common
323         exec >&6
324         say_color error '%-6s' FATAL
325         echo " $*"
326         echo
327         echo "Unexpected exit while executing $0."
328         exit 1
329 }
330
331 GIT_EXIT_OK=
332 # Note: TEST_TMPDIR *NOT* exported!
333 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
334 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
335 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
336 trap 'trap_exit' EXIT
337 trap 'trap_signal' HUP INT TERM
338
339 # Deliver a message with emacs and add it to the database
340 #
341 # Uses emacs to generate and deliver a message to the mail store.
342 # Accepts arbitrary extra emacs/elisp functions to modify the message
343 # before sending, which is useful to doing things like attaching files
344 # to the message and encrypting/signing.
345 emacs_deliver_message ()
346 {
347     local subject body smtp_dummy_pid smtp_dummy_port
348     subject="$1"
349     body="$2"
350     shift 2
351     # before we can send a message, we have to prepare the FCC maildir
352     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
353     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
354     smtp_dummy_pid= smtp_dummy_port=
355     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
356     test -n "$smtp_dummy_pid" || return 1
357     test -n "$smtp_dummy_port" || return 1
358
359     test_emacs \
360         "(let ((message-send-mail-function 'message-smtpmail-send-it)
361                (mail-host-address \"example.com\")
362                (smtpmail-smtp-server \"localhost\")
363                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
364            (notmuch-mua-mail)
365            (message-goto-to)
366            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
367            (message-goto-subject)
368            (insert \"${subject}\")
369            (message-goto-body)
370            (insert \"${body}\")
371            $*
372            (notmuch-mua-send-and-exit))"
373
374     # In case message was sent properly, client waits for confirmation
375     # before exiting and resuming control here; therefore making sure
376     # that server exits by sending (KILL) signal to it is safe.
377     kill -9 $smtp_dummy_pid
378     notmuch new >/dev/null
379 }
380
381 # Pretend to deliver a message with emacs. Really save it to a file
382 # and add it to the database
383 #
384 # Uses emacs to generate and deliver a message to the mail store.
385 # Accepts arbitrary extra emacs/elisp functions to modify the message
386 # before sending, which is useful to doing things like attaching files
387 # to the message and encrypting/signing.
388 #
389 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
390 # at the head of the argument list, they are sent directly to "notmuch
391 # new" after message delivery
392 emacs_fcc_message ()
393 {
394     local nmn_args subject body
395     nmn_args=''
396     while [[ "$1" =~ ^-- ]]; do
397         nmn_args="$nmn_args $1"
398         shift
399     done
400     subject="$1"
401     body="$2"
402     shift 2
403     # before we can send a message, we have to prepare the FCC maildir
404     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
405
406     test_emacs \
407         "(let ((message-send-mail-function (lambda () t))
408                (mail-host-address \"example.com\"))
409            (notmuch-mua-mail)
410            (message-goto-to)
411            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
412            (message-goto-subject)
413            (insert \"${subject}\")
414            (message-goto-body)
415            (insert \"${body}\")
416            $*
417            (notmuch-mua-send-and-exit))" || return 1
418     notmuch new $nmn_args >/dev/null
419 }
420
421 # Add an existing, fixed corpus of email to the database.
422 #
423 # $1 is the corpus dir under corpora to add, using "default" if unset.
424 #
425 # The default corpus is based on about 50 messages from early in the
426 # history of the notmuch mailing list, which allows for reliably
427 # testing commands that need to operate on a not-totally-trivial
428 # number of messages.
429 add_email_corpus ()
430 {
431     local corpus
432     corpus=${1:-default}
433
434     rm -rf ${MAIL_DIR}
435     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
436     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
437 }
438
439 test_begin_subtest ()
440 {
441     if [ -n "$inside_subtest" ]; then
442         exec 1>&6 2>&7          # Restore stdout and stderr
443         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
444     fi
445     test_subtest_name="$1"
446     test_reset_state_
447     # Redirect test output to the previously prepared file descriptors
448     # 3 and 4 (see below)
449     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
450     exec >&3 2>&4
451     inside_subtest=t
452 }
453
454 # Pass test if two arguments match
455 #
456 # Note: Unlike all other test_expect_* functions, this function does
457 # not accept a test name. Instead, the caller should call
458 # test_begin_subtest before calling this function in order to set the
459 # name.
460 test_expect_equal ()
461 {
462         local output expected testname
463         exec 1>&6 2>&7          # Restore stdout and stderr
464         if [ -z "$inside_subtest" ]; then
465                 error "bug in the test script: test_expect_equal without test_begin_subtest"
466         fi
467         inside_subtest=
468         test "$#" = 2 ||
469         error "bug in the test script: not 2 parameters to test_expect_equal"
470
471         output="$1"
472         expected="$2"
473         if ! test_skip "$test_subtest_name"
474         then
475                 if [ "$output" = "$expected" ]; then
476                         test_ok_
477                 else
478                         testname=$this_test.$test_count
479                         echo "$expected" > $testname.expected
480                         echo "$output" > $testname.output
481                         test_failure_ "$(diff -u $testname.expected $testname.output)"
482                 fi
483     fi
484 }
485
486 # Like test_expect_equal, but takes two filenames.
487 test_expect_equal_file ()
488 {
489         local file1 file2 testname basename1 basename2
490         exec 1>&6 2>&7          # Restore stdout and stderr
491         if [ -z "$inside_subtest" ]; then
492                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
493         fi
494         inside_subtest=
495         test "$#" = 2 ||
496         error "bug in the test script: not 2 parameters to test_expect_equal_file"
497
498         file1="$1"
499         file2="$2"
500         if ! test_skip "$test_subtest_name"
501         then
502                 if diff -q "$file1" "$file2" >/dev/null ; then
503                         test_ok_
504                 else
505                         testname=$this_test.$test_count
506                         basename1=`basename "$file1"`
507                         basename2=`basename "$file2"`
508                         cp "$file1" "$testname.$basename1"
509                         cp "$file2" "$testname.$basename2"
510                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
511                 fi
512     fi
513 }
514
515 # Like test_expect_equal, but arguments are JSON expressions to be
516 # canonicalized before diff'ing.  If an argument cannot be parsed, it
517 # is used unchanged so that there's something to diff against.
518 test_expect_equal_json () {
519     local script output expected
520     # The test suite forces LC_ALL=C, but this causes Python 3 to
521     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
522     # override Python's stdio encoding defaults.
523     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
524     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
525         || echo "$1")
526     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
527         || echo "$2")
528     shift 2
529     test_expect_equal "$output" "$expected" "$@"
530 }
531
532 # Ensure that the argument is valid JSON data.
533 test_valid_json () {
534     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
535     test_expect_equal "$?" 0
536 }
537
538 # Sort the top-level list of JSON data from stdin.
539 test_sort_json () {
540     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
541         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
542 }
543
544 # test for json objects:
545 # read the source of test/json_check_nodes.py (or the output when
546 # invoking it without arguments) for an explanation of the syntax.
547 test_json_nodes () {
548         local output
549         exec 1>&6 2>&7          # Restore stdout and stderr
550         if [ -z "$inside_subtest" ]; then
551                 error "bug in the test script: test_json_eval without test_begin_subtest"
552         fi
553         inside_subtest=
554         test "$#" > 0 ||
555             error "bug in the test script: test_json_nodes needs at least 1 parameter"
556
557         if ! test_skip "$test_subtest_name"
558         then
559             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
560                 if [ "$?" = 0 ]
561                 then
562                         test_ok_
563                 else
564                         test_failure_ "$output"
565                 fi
566         fi
567 }
568
569 test_emacs_expect_t () {
570         local result
571         test "$#" = 1 ||
572         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
573         if [ -z "$inside_subtest" ]; then
574                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
575         fi
576
577         # Run the test.
578         if ! test_skip "$test_subtest_name"
579         then
580                 test_emacs "(notmuch-test-run $1)" >/dev/null
581
582                 # Restore state after the test.
583                 exec 1>&6 2>&7          # Restore stdout and stderr
584                 inside_subtest=
585
586                 # Report success/failure.
587                 result=$(cat OUTPUT)
588                 if [ "$result" = t ]
589                 then
590                         test_ok_
591                 else
592                         test_failure_ "${result}"
593                 fi
594         else
595                 # Restore state after the (non) test.
596                 exec 1>&6 2>&7          # Restore stdout and stderr
597                 inside_subtest=
598         fi
599 }
600
601 NOTMUCH_NEW ()
602 {
603     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
604 }
605
606 NOTMUCH_DUMP_TAGS ()
607 {
608     # this relies on the default format being batch-tag, otherwise some tests will break
609     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
610 }
611
612 notmuch_drop_mail_headers ()
613 {
614     $NOTMUCH_PYTHON -c '
615 import email, sys
616 msg = email.message_from_file(sys.stdin)
617 for hdr in sys.argv[1:]: del msg[hdr]
618 print(msg.as_string(False))
619 ' "$@"
620 }
621
622 notmuch_search_sanitize ()
623 {
624     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
625 }
626
627 notmuch_search_files_sanitize ()
628 {
629     notmuch_dir_sanitize
630 }
631
632 notmuch_dir_sanitize ()
633 {
634     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
635 }
636
637 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
638 notmuch_show_sanitize ()
639 {
640     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
641 }
642 notmuch_show_sanitize_all ()
643 {
644     sed \
645         -e 's| filename:.*| filename:XXXXX|' \
646         -e 's| id:[^ ]* | id:XXXXX |' | \
647         notmuch_date_sanitize
648 }
649
650 notmuch_json_show_sanitize ()
651 {
652     sed \
653         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
654         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
655         -e 's|"filename": "signature.asc",||g' \
656         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
657         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
658         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
659 }
660
661 notmuch_emacs_error_sanitize ()
662 {
663     local command
664     command=$1
665     shift
666     for file in "$@"; do
667         echo "=== $file ==="
668         cat "$file"
669     done | sed  \
670         -e 's/^\[.*\]$/[XXX]/' \
671         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
672 }
673
674 notmuch_date_sanitize ()
675 {
676     sed \
677         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
678 }
679
680 notmuch_uuid_sanitize ()
681 {
682     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
683 }
684
685 notmuch_built_with_sanitize ()
686 {
687     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
688 }
689
690 notmuch_config_sanitize ()
691 {
692     notmuch_dir_sanitize | notmuch_built_with_sanitize
693 }
694
695 notmuch_show_part ()
696 {
697     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
698 }
699
700 # End of notmuch helper functions
701
702 # Use test_set_prereq to tell that a particular prerequisite is available.
703 #
704 # The prerequisite can later be checked for by using test_have_prereq.
705 #
706 # The single parameter is the prerequisite tag (a simple word, in all
707 # capital letters by convention).
708
709 test_set_prereq () {
710         satisfied="$satisfied$1 "
711 }
712 satisfied=" "
713
714 test_have_prereq () {
715         case $satisfied in
716         *" $1 "*)
717                 : yes, have it ;;
718         *)
719                 ! : nope ;;
720         esac
721 }
722
723 declare -A test_missing_external_prereq_
724 declare -A test_subtest_missing_external_prereq_
725
726 # declare prerequisite for the given external binary
727 test_declare_external_prereq () {
728         local binary
729         binary="$1"
730         test "$#" = 2 && name=$2 || name="$binary(1)"
731
732         if ! hash $binary 2>/dev/null; then
733                 test_missing_external_prereq_["${binary}"]=t
734                 eval "
735 $binary () {
736         test_subtest_missing_external_prereq_[\"${name}\"]=t
737         false
738 }"
739         fi
740 }
741
742 # Explicitly require external prerequisite.  Useful when binary is
743 # called indirectly (e.g. from emacs).
744 # Returns success if dependency is available, failure otherwise.
745 test_require_external_prereq () {
746         local binary
747         binary="$1"
748         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
749                 # dependency is missing, call the replacement function to note it
750                 eval "$binary"
751         else
752                 true
753         fi
754 }
755
756 # You are not expected to call test_ok_ and test_failure_ directly, use
757 # the text_expect_* functions instead.
758
759 test_ok_ () {
760         if test "$test_subtest_known_broken_" = "t"; then
761                 test_known_broken_ok_
762                 return
763         fi
764         test_success=$(($test_success + 1))
765         if test -n "$NOTMUCH_TEST_QUIET"; then
766                 return 0
767         fi
768         say_color pass "%-6s" "PASS"
769         echo " $test_subtest_name"
770 }
771
772 test_failure_ () {
773         print_test_description
774         if test "$test_subtest_known_broken_" = "t"; then
775                 test_known_broken_failure_ "$@"
776                 return
777         fi
778         test_failure=$(($test_failure + 1))
779         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
780         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
781         return 1
782 }
783
784 test_failure_message_ () {
785         say_color error "%-6s" "$1"
786         echo " $2"
787         shift 2
788         if [ "$#" != "0" ]; then
789                 echo "$@" | sed -e 's/^/        /'
790         fi
791         if test "$verbose" != "t"; then cat test.output; fi
792 }
793
794 test_known_broken_ok_ () {
795         test_reset_state_
796         test_fixed=$(($test_fixed+1))
797         say_color pass "%-6s" "FIXED"
798         echo " $test_subtest_name"
799 }
800
801 test_known_broken_failure_ () {
802         test_reset_state_
803         test_broken=$(($test_broken+1))
804         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
805                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
806         else
807                 test_failure_message_ "BROKEN" "$test_subtest_name"
808         fi
809         return 1
810 }
811
812 test_debug () {
813         test "$debug" = "" || eval "$1"
814 }
815
816 test_run_ () {
817         test_cleanup=:
818         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
819         eval >&3 2>&4 "$1"
820         eval_ret=$?
821         eval >&3 2>&4 "$test_cleanup"
822         return 0
823 }
824
825 test_skip () {
826         test_count=$(($test_count+1))
827         to_skip=
828         for skp in $NOTMUCH_SKIP_TESTS
829         do
830                 case $this_test.$test_count in
831                 $skp)
832                         to_skip=t
833                         break
834                 esac
835                 case $this_test_bare.$test_count in
836                 $skp)
837                         to_skip=t
838                         break
839                 esac
840         done
841         case "$to_skip" in
842         t)
843                 test_report_skip_ "$@"
844                 ;;
845         *)
846                 test_check_missing_external_prereqs_ "$@"
847                 ;;
848         esac
849 }
850
851 test_check_missing_external_prereqs_ () {
852         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
853                 say_color skip >&1 "missing prerequisites: "
854                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
855                 test_report_skip_ "$@"
856         else
857                 false
858         fi
859 }
860
861 test_report_skip_ () {
862         test_reset_state_
863         say_color skip >&3 "skipping test:"
864         echo " $@" >&3
865         say_color skip "%-6s" "SKIP"
866         echo " $1"
867 }
868
869 test_subtest_known_broken () {
870         test_subtest_known_broken_=t
871 }
872
873 test_expect_success () {
874         exec 1>&6 2>&7          # Restore stdout and stderr
875         if [ -z "$inside_subtest" ]; then
876                 error "bug in the test script: test_expect_success without test_begin_subtest"
877         fi
878         inside_subtest=
879         test "$#" = 1 ||
880         error "bug in the test script: not 1 parameters to test_expect_success"
881
882         if ! test_skip "$test_subtest_name"
883         then
884                 test_run_ "$1"
885                 run_ret="$?"
886                 # test_run_ may update missing external prerequisites
887                 test_check_missing_external_prereqs_ "$@" ||
888                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
889                 then
890                         test_ok_
891                 else
892                         test_failure_ "$1"
893                 fi
894         fi
895 }
896
897 test_expect_code () {
898         exec 1>&6 2>&7          # Restore stdout and stderr
899         if [ -z "$inside_subtest" ]; then
900                 error "bug in the test script: test_expect_code without test_begin_subtest"
901         fi
902         inside_subtest=
903         test "$#" = 2 ||
904         error "bug in the test script: not 2 parameters to test_expect_code"
905
906         if ! test_skip "$test_subtest_name"
907         then
908                 test_run_ "$2"
909                 run_ret="$?"
910                 # test_run_ may update missing external prerequisites,
911                 test_check_missing_external_prereqs_ "$@" ||
912                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
913                 then
914                         test_ok_
915                 else
916                         test_failure_ "exit code $eval_ret, expected $1" "$2"
917                 fi
918         fi
919 }
920
921 # This is not among top-level (test_expect_success)
922 # but is a prefix that can be used in the test script, like:
923 #
924 #       test_expect_success 'complain and die' '
925 #           do something &&
926 #           do something else &&
927 #           test_must_fail git checkout ../outerspace
928 #       '
929 #
930 # Writing this as "! git checkout ../outerspace" is wrong, because
931 # the failure could be due to a segv.  We want a controlled failure.
932
933 test_must_fail () {
934         "$@"
935         test $? -gt 0 -a $? -le 129 -o $? -gt 192
936 }
937
938 # test_cmp is a helper function to compare actual and expected output.
939 # You can use it like:
940 #
941 #       test_expect_success 'foo works' '
942 #               echo expected >expected &&
943 #               foo >actual &&
944 #               test_cmp expected actual
945 #       '
946 #
947 # This could be written as either "cmp" or "diff -u", but:
948 # - cmp's output is not nearly as easy to read as diff -u
949 # - not all diff versions understand "-u"
950
951 test_cmp() {
952         $GIT_TEST_CMP "$@"
953 }
954
955 # This function can be used to schedule some commands to be run
956 # unconditionally at the end of the test to restore sanity:
957 #
958 #       test_expect_success 'test core.capslock' '
959 #               git config core.capslock true &&
960 #               test_when_finished "git config --unset core.capslock" &&
961 #               hello world
962 #       '
963 #
964 # That would be roughly equivalent to
965 #
966 #       test_expect_success 'test core.capslock' '
967 #               git config core.capslock true &&
968 #               hello world
969 #               git config --unset core.capslock
970 #       '
971 #
972 # except that the greeting and config --unset must both succeed for
973 # the test to pass.
974
975 test_when_finished () {
976         test_cleanup="{ $*
977                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
978 }
979
980 test_done () {
981         GIT_EXIT_OK=t
982         test_results_dir="$TEST_DIRECTORY/test-results"
983         mkdir -p "$test_results_dir"
984         test_results_path="$test_results_dir/$this_test"
985
986         echo "total $test_count" >> $test_results_path
987         echo "success $test_success" >> $test_results_path
988         echo "fixed $test_fixed" >> $test_results_path
989         echo "broken $test_broken" >> $test_results_path
990         echo "failed $test_failure" >> $test_results_path
991         echo "" >> $test_results_path
992
993         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
994
995         if [ "$test_failure" = "0" ]; then
996             if [ "$test_broken" = "0" ]; then
997                 rm -rf "$remove_tmp"
998             fi
999             exit 0
1000         else
1001             exit 1
1002         fi
1003 }
1004
1005 emacs_generate_script () {
1006         # Construct a little test script here for the benefit of the user,
1007         # (who can easily run "run_emacs" to get the same emacs environment
1008         # for investigating any failures).
1009         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1010 #!/bin/sh
1011 export PATH=$PATH
1012 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1013
1014 # Here's what we are using here:
1015 #
1016 # --quick              Use minimal customization. This implies --no-init-file,
1017 #                      --no-site-file and (emacs 24) --no-site-lisp
1018 #
1019 # --directory           Ensure that the local elisp sources are found
1020 #
1021 # --load                Force loading of notmuch.el and test-lib.el
1022
1023 exec ${TEST_EMACS} --quick \
1024         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1025         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1026         "\$@"
1027 EOF
1028         chmod a+x "$TMP_DIRECTORY/run_emacs"
1029 }
1030
1031 test_emacs () {
1032         # test dependencies beforehand to avoid the waiting loop below
1033         missing_dependencies=
1034         test_require_external_prereq dtach || missing_dependencies=1
1035         test_require_external_prereq emacs || missing_dependencies=1
1036         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1037         test -z "$missing_dependencies" || return
1038
1039         if [ -z "$EMACS_SERVER" ]; then
1040                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1041                 if [ -f "$emacs_tests" ]; then
1042                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1043                 else
1044                         load_emacs_tests=
1045                 fi
1046                 server_name="notmuch-test-suite-$$"
1047                 # start a detached session with an emacs server
1048                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1049                 # or unknown) is given to dtach which assumes a minimally
1050                 # VT100-compatible terminal -- and emacs inherits that
1051                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1052                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1053                                 --no-window-system \
1054                                 $load_emacs_tests \
1055                                 --eval '(setq server-name \"$server_name\")' \
1056                                 --eval '(server-start)' \
1057                                 --eval '(orphan-watchdog $$)'" || return
1058                 EMACS_SERVER="$server_name"
1059                 # wait until the emacs server is up
1060                 until test_emacs '()' >/dev/null 2>/dev/null; do
1061                         sleep 1
1062                 done
1063         fi
1064
1065         # Clear test-output output file.  Most Emacs tests end with a
1066         # call to (test-output).  If the test code fails with an
1067         # exception before this call, the output file won't get
1068         # updated.  Since we don't want to compare against an output
1069         # file from another test, so start out with an empty file.
1070         rm -f OUTPUT
1071         touch OUTPUT
1072
1073         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1074 }
1075
1076 test_python() {
1077     # Note: if there is need to print debug information from python program,
1078     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1079     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1080         $NOTMUCH_PYTHON -B - > OUTPUT
1081 }
1082
1083 test_ruby() {
1084     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1085 }
1086
1087 test_C () {
1088     local exec_file test_file
1089     exec_file="test${test_count}"
1090     test_file="${exec_file}.c"
1091     cat > ${test_file}
1092     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1093     echo "== stdout ==" > OUTPUT.stdout
1094     echo "== stderr ==" > OUTPUT.stderr
1095     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1096     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1097 }
1098
1099 make_shim () {
1100     local base_name test_file shim_file
1101     base_name="$1"
1102     test_file="${base_name}.c"
1103     shim_file="${base_name}.so"
1104     cat > ${test_file}
1105     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1106 }
1107
1108 notmuch_with_shim () {
1109     local base_name shim_file
1110     base_name="$1"
1111     shift
1112     shim_file="${base_name}.so"
1113     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1114 }
1115
1116 # Creates a script that counts how much time it is executed and calls
1117 # notmuch.  $notmuch_counter_command is set to the path to the
1118 # generated script.  Use notmuch_counter_value() function to get the
1119 # current counter value.
1120 notmuch_counter_reset () {
1121         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1122         if [ ! -x "$notmuch_counter_command" ]; then
1123                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1124                 cat >"$notmuch_counter_command" <<EOF || return
1125 #!/bin/sh
1126
1127 read count < "$notmuch_counter_state_path"
1128 echo \$((count + 1)) > "$notmuch_counter_state_path"
1129
1130 exec notmuch "\$@"
1131 EOF
1132                 chmod +x "$notmuch_counter_command" || return
1133         fi
1134
1135         echo 0 > "$notmuch_counter_state_path"
1136 }
1137
1138 # Returns the current notmuch counter value.
1139 notmuch_counter_value () {
1140         if [ -r "$notmuch_counter_state_path" ]; then
1141                 read count < "$notmuch_counter_state_path"
1142         else
1143                 count=0
1144         fi
1145         echo $count
1146 }
1147
1148 test_reset_state_ () {
1149         test -z "$test_init_done_" && test_init_
1150
1151         test_subtest_known_broken_=
1152         test_subtest_missing_external_prereq_=()
1153 }
1154
1155 # called once before the first subtest
1156 test_init_ () {
1157         test_init_done_=t
1158
1159         # skip all tests if there were external prerequisites missing during init
1160         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1161 }
1162
1163
1164 # Where to run the tests
1165 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1166
1167 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1168
1169 emacs_generate_script
1170
1171
1172 # Use -P to resolve symlinks in our working directory so that the cwd
1173 # in subprocesses like git equals our $PWD (for pathname comparisons).
1174 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1175
1176 if test "$verbose" = "t"
1177 then
1178         exec 4>&2 3>&1
1179 else
1180         exec 4>test.output 3>&4
1181 fi
1182
1183 for skp in $NOTMUCH_SKIP_TESTS
1184 do
1185         to_skip=
1186         for skp in $NOTMUCH_SKIP_TESTS
1187         do
1188                 case "$this_test" in
1189                 $skp)
1190                         to_skip=t
1191                         break
1192                 esac
1193                 case "$this_test_bare" in
1194                 $skp)
1195                         to_skip=t
1196                         break
1197                 esac
1198         done
1199         case "$to_skip" in
1200         t)
1201                 say_color skip >&3 "skipping test $this_test altogether"
1202                 say_color skip "skip all tests in $this_test"
1203                 test_done
1204         esac
1205 done
1206
1207 # Provide an implementation of the 'yes' utility
1208 yes () {
1209         if test $# = 0
1210         then
1211                 y=y
1212         else
1213                 y="$*"
1214         fi
1215
1216         while echo "$y"
1217         do
1218                 :
1219         done
1220 }
1221
1222 # Fix some commands on Windows
1223 case $(uname -s) in
1224 *MINGW*)
1225         # Windows has its own (incompatible) sort and find
1226         sort () {
1227                 /usr/bin/sort "$@"
1228         }
1229         find () {
1230                 /usr/bin/find "$@"
1231         }
1232         sum () {
1233                 md5sum "$@"
1234         }
1235         # git sees Windows-style pwd
1236         pwd () {
1237                 builtin pwd -W
1238         }
1239         # no POSIX permissions
1240         # backslashes in pathspec are converted to '/'
1241         # exec does not inherit the PID
1242         ;;
1243 *)
1244         test_set_prereq POSIXPERM
1245         test_set_prereq BSLASHPSPEC
1246         test_set_prereq EXECKEEPSPID
1247         ;;
1248 esac
1249
1250 test -z "$NO_PERL" && test_set_prereq PERL
1251 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1252
1253 # test whether the filesystem supports symbolic links
1254 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1255 rm -f y
1256
1257 # convert variable from configure to more convenient form
1258 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1259     glass)
1260         db_ending=glass
1261     ;;
1262     chert)
1263         db_ending=DB
1264     ;;
1265     *)
1266         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1267 esac
1268 # declare prerequisites for external binaries used in tests
1269 test_declare_external_prereq dtach
1270 test_declare_external_prereq emacs
1271 test_declare_external_prereq ${TEST_EMACSCLIENT}
1272 test_declare_external_prereq ${TEST_GDB}
1273 test_declare_external_prereq gpg
1274 test_declare_external_prereq openssl
1275 test_declare_external_prereq gpgsm
1276 test_declare_external_prereq ${NOTMUCH_PYTHON}